#!/usr/local/bin/perl

# ===========================================================================
# File: processreview.cgi
# Provided by: Dr. Kevin Ham
# http://www.hostglobal.com - Web Hosting & Resource Directory 
# Version 1.0
# This script is freeware only on the condition that you rate and review your
# your host at http://hostglobal.com OR add an appropriate resource.
# You may not redistribute this script or a modification of it without consent.
# If you would like updates and support for this script, send me a $30 US cheque.
# Email me at kdham@mail.puterdudes.com for the address.
# =============================================================================
# Required Librariers
# --------------------------------------------------------
eval {
    ($0 =~ m,(.*)/[^/]+,)   && unshift (@INC, "$1");    # Get the script location: UNIX /
    ($0 =~ m,(.*)\\[^\\]+,) && unshift (@INC, "$1");    # Get the script location: Windows \

 require "review.cfg"; # Change this to the full path of review.cfg if you have problems
 require "header_footer.cfg"; # Change this to the full path of header_footer.cfg if you have problems.
};

if ($@) {
    print "Content-type: text/plain\n\n";
    print "Error including libraries: $@\n";
    print "Make sure they exist, permissions are set properly, and paths are set correctly.";
    exit;
}

$EXCLUSIVE = 2;
$UNLOCK    = 8;

# Parse form input
&parse_form;

#************Edit the fields below if you've changed the fields in addreview.cgi***********
# eg.  in the Title example of addreview.cgi you would add $Title=$FORM{'Title'}; 

  $ID=$FORM{'ID'};
  $url=$FORM{'url'};
  $name=$FORM{'name'};
  $email=$FORM{'email'};
  $site=$FORM{'site'};
  $IP=$FORM{'IP'};
  $support=$FORM{'support'};
  $rating=$FORM{'rating'};
  $review=$FORM{'review'};

# Enter your admin email address here to be mailed to you
  $admin="yourname\@yoursite.com";  # Do not erase the \ or you will get an error

# URL to your links directory * not where your cgi scripts are held
  $links_files="http\://hostglobal.com/links"; # this is for the link to Detailed so turn it on in links.cfg
#********************************************************************************************

&get_date;

#***********************************************************************************
# Edit this if you change the fields in addreview.cgi and also change the fields
# in review.cfg.  This joins the fields that the visitor filled out.
#============================================================================
  $record = join ('|',$date,$ID,$url,$name,$email,$site,$IP,$support,$rating,$review);
#***********************************************************************************

#============================================================================
&valid_address;
&review;
&add_record($db_review,$returnto,$record);
&record_added;
&process_mail;
&do_log;
&print_review;
exit;

#============================================================================
## Subroutines

#========================================
# Get the date.

sub get_date {
   @days =
('Sunday','Monday','Tuesday','Wednesday','Thursday','Friday','Saturday');
   @months = ('January','February','March','April','May','June','July',
              'August','September','October','November','December');

   ($sec,$min,$hour,$mday,$mon,$year,$wday) =
localtime(time);
   if ($hour < 10) { $hour = "0$hour"; }
   if ($min < 10) { $min = "0$min"; }
   if ($sec < 10) { $sec = "0$sec"; }

   $date = "$days[$wday], $months[$mon] $mday, 19$year at $hour\:$min\:$sec";

}

#========================================
sub add_record{
$db_review=$_[0];
$record  =$_[1];
   open (DB,">>$db_review") or die "Error: $!\n";
   flock DB, $EXCLUSIVE;        # Lock the file so nobody else uses it.
    seek DB, 0, 2;
    print DB "$record\n";
   flock DB, $UNLOCK;
   close(DB);
return;  
} # End of sub add_record

#========================================
sub valid_address 
{
        $temp = $email;
        $temp =~ s/_/a/g; $temp =~ s/-/a/g;
        unless ($temp =~ /\w+@\w+\.\w\w+/) {

&print_header;
    print "<center><h1>Please enter a valid email address\n";
    print "Hit your back button and enter a valid email address.\n\n\n</center></h1>";
&print_footer;
exit;
} # end of unless
} # end of sub

sub review {
unless ($review) { 
&print_header;
        print "<center><h1>You forgot the review.\n";
        print "Please go back and add your review</center></h1>\n\n\n";
        print "\n\n";
&print_footer;
exit;
} # end of unless
} # end of sub

#========================================
sub do_log
{
	(-e $LOGFILE) ?
		open (LOG,">>$LOGFILE") :
		open (LOG,">$LOGFILE");
	$date=localtime(time);
	  {
 		next;
	}

#**********************************************************************************************
#== Edit this if you change the fields in addreview.cgi and also change the fields==
#== in review.cfg.  This joins the fields that the visitor filled out and stores it in a log====
  $record = join ('|',$date,$ID,$url,$name,$email,$site,$IP,$support,$rating,$review);
#***********************************************************************************************
	print LOG "$record\n";
	close(LOG);
}

#========================================
sub print_review
{
$date=localtime(time);

#***********************************************************************************************
#== Edit the variables if you've changed them in addreview.cgi eg. $support
#**********************************************************************************************

open (FILE,"$Reviews");
@lines = <FILE>;
close (FILE);

open (FILE,">$Reviews"); # overwrites between <!--add-->
   flock FILE, $EXCLUSIVE;        # Lock the file so nobody else uses it.
    seek FILE, 0, 2;

  foreach $line(@lines) {
        if (substr($line,0,10) eq "<!--add-->") {
          print FILE "<!--add-->\n";
           print FILE "<div align=\"center\"><center>
              <table width=\"670\" bgcolor=\"#FFFFFF\">
               <tr><td align=\"left\">$name of $site reviewed <a href=\"$links_files/Detailed/$ID.html\">$url</a> on $date.</td></tr>\n";
           print FILE "<tr><td align=\"left\">$rating recommendation. $support support.</td></tr>\n";
           print FILE "<tr><td width=\"670\" align=\"left\" bgColor=\"#EFEFEF\">&nbsp;&nbsp;$review<br>
               To see other reviews for this resource, <a href=\"$link_location/review.cgi\?ID=$ID\">Click here</a>
              </td></tr>
              </table></center></div><br>\n";
        } # end of if
        else { print FILE "$line"; }
  } # end of foreach
flock FILE, $UNLOCK;
close (FILE);
} # end of sub

#======================================
sub process_mail {
	open (MAIL_RECIP, "|$MAIL_PROGRAM");             

print MAIL_RECIP "To: $admin, $email\n";
print MAIL_RECIP "From: $email\n";
print MAIL_RECIP "Subject: Review Added\n";

print MAIL_RECIP "Thank you $name ($email) from $site for adding the following review for $url\n";
print MAIL_RECIP "on $date.\n";
print MAIL_RECIP "$review\n";
close(MAIL_RECIP);
}

sub record_added {
if (&valid_address == 0)
	{
		next;
	}
& print_header;

print<<HTML;
 <FONT SIZE=5>
 <CENTER>Thank you $name. Your review of $url has been added!</CENTER></FONT><br>
 <center>$date ($email - $IP)</center><br>
 <p><center>
<form action="$link_location/rate.cgi" method="POST">
      <input type="hidden" name="ID" value="$ID">
<div align="center"><center>
<p>Please rate the link <strong><a href="$url">$url</a></strong> between 1 and 10, with 10 being the best.</p>
      </center></div><div class="margin"><div align="center"><center><p><select name="rate" size="1">
        <option>--- </option>
        <option>1 </option>
        <option>2 </option>
        <option>3 </option>
        <option>4 </option>
        <option>5 </option>
        <option>6 </option>
        <option>7 </option>
        <option>8 </option>
        <option>9 </option>
        <option>10 </option>
      </select> <input type="submit" value="Rate this Resource"> </p>
      </center></div></div>
    </form> 
<br></center></p>
HTML

& print_footer;
return;
}

#==================================================
# parse form input
sub parse_form {
my(@pairs);
   if ($ENV{'REQUEST_METHOD'} eq 'GET') {
      # Split the name-value pairs
      @pairs = split(/&/, $ENV{'QUERY_STRING'});
   }
   elsif ($ENV{'REQUEST_METHOD'} eq 'POST') {
      # Get the input
      read(STDIN, $buffer, $ENV{'CONTENT_LENGTH'});
 
      # Split the name-value pairs
      @pairs = split(/&/, $buffer);
   }
   else {
      &error('request_method');
   }

   foreach $pair (@pairs) {
      my($name, $value) = split(/=/, $pair);
 
      $name =~ tr/+/ /;
      $name =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;

      $value =~ tr/+/ /;
      $value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;

      # If they try to include server side includes, erase them, so they
      # arent a security risk if the html gets returned.  Another 
      # security hole plugged up.

      $value =~ s/<!--(.|\n)*-->//g;

      # Create two associative arrays here.  One is a configuration array
      # which includes all fields that this form recognizes.  The other
      # is for fields which the form does not recognize and will report 
      # back to the user in the html return page and the e-mail message.
      # Also determine required fields.

      if ($name eq 'bgcolor' ||
          $name eq 'background' ||
          $name eq 'link_color' ||
          $name eq 'vlink_color' ||
      $name eq 'text_color' ||
          $name eq 'alink_color' ||
          $name eq 'title' ||
          $name eq 'sort' ||
          $name eq 'print_config' ||
          $name eq 'return_link_title' ||
          $name eq 'return_link_url' && ($value)) {
         
         $CONFIG{$name} = $value;
      }
      elsif ($name eq 'required') {
         @required = split(/,/,$value);
      }
      elsif ($name eq 'exclude') {
        @exclude = split(/,/,$value);
        }
      else {
         if ($FORM{$name} && ($value)) {
            $FORM{$name} = "$FORM{$name}, $value";
         }
         elsif ($value) {
            $FORM{$name} = $value;
         }
      }
   }
}